#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/05/02
#Last Modify: 2018/05/02
# deeper learning insights machine learning page 611

from sklearn import datasets
from sklearn.cross_validation import train_test_split
from sklearn.grid_search import GridSearchCV
from sklearn.metrics import classification_report
from sklearn.linear_model import LogisticRegression as lr
X,y=datasets.make_blobs(n_samples=800,centers=2, random_state=0, cluster_std=4)
X_train, X_test, y_train, y_test = train_test_split(X,
                                                    y,
                                                    test_size=0.5,
                                                    random_state=0)
tuned_parameters = [{'penalty': ['l1'],
                     'C': [0.01, 0.1, 1, 5]},
                    {'penalty': ['l2'], 'C': [0.01, 0.1, 1, 5]}]
scores = ['precision', 'recall','f1']
for score in scores:
  clf = GridSearchCV(lr(C=1),
                     tuned_parameters,
                     cv=5,
                     scoring='%s_weighted' % score)
  clf.fit(X_train, y_train)
  print("Best parameters on development set:")
  print()
  print(clf.best_params_)
  print("Grid scores on development set:")
  for params, mean_score, scores in clf.grid_scores_:
    print("%0.3f (+/-%0.03f) for %r" % (mean_score, scores.std() * 2, params))
  print("classification report:")
  y_true, y_pred = y_test, clf.predict(X_test)
  print(classification_report(y_true, y_pred))
